<?php

namespace Plugins\Notebook;

use App\Interfaces\PluginsInstallInterface;
use App\Model\Base\Route;
use App\Util\Hy;
use App\Util\PluginsInstallHelper;
use Hyperf\DbConnection\Db;

class Install implements PluginsInstallInterface
{

    public static function run(): void
    {
        self::addMenu();
        self::addResource();
    }


    private static function addMenu(): void
    {
        $table = Route::getPrefix() . Route::table();

        // 添加菜单
        Db::insert("INSERT INTO `$table` (`pid`, `type`, `title`, `icon`, `route`, `power_route`, `weigh`, `create_time`, `update_time`, `delete_time`) VALUES (0, 1, '笔记本', 'Document', '/admin/plugins/notebook/lists', NULL, 1, '2023-09-24 12:36:45', '2023-09-24 12:36:45', NULL);");
    }

    private static function addResource(): void
    {
        PluginsInstallHelper::addResource(__DIR__ . '/resource/wangeditor_editor@5.1.23_dist_css_style.css', '/static/wangeditor_editor@5.1.23_dist_css_style.css');
        PluginsInstallHelper::addResource(__DIR__ . '/resource/wangeditor_editor@5.1.23_dist_index.js', '/static/wangeditor_editor@5.1.23_dist_index.js');
        PluginsInstallHelper::addResource(__DIR__ . '/resource/normalize_8.0.1_normalize.min.css', '/static/normalize_8.0.1_normalize.min.css');
    }
}