@extends('Admin.layout')
@section('header')
{{--    <link rel="stylesheet" href="/froala/froala_editor.pkgd.min.css" />--}}
{{--    <script src="/froala/froala_editor.pkgd.min.js"></script>--}}
{{--    <script src="/froala/zh_cn.js"></script>--}}
    <link href="/static/wangeditor_editor@5.1.23_dist_css_style.css" rel="stylesheet">
    <link href="/static/normalize_8.0.1_normalize.min.css" rel="stylesheet">
    <script src="/static/wangeditor_editor@5.1.23_dist_index.js"></script>
    <style>
        .notebook-lists.warning-background{
            background-color: #fdf6ec;
            color: #b88230;
        }
        .notebook-lists.success-background{
            background-color: #f0f9eb;
            color: #529b2e;
        }
        .notebook-lists{
            margin: 0 5px 5px;
            box-sizing: border-box;
            border-radius: 10px;
            padding:10px;
            font-size: 14px;
            position: relative;
        }
        .notebook-lists:hover{
            cursor: pointer;
        }
        .notebook-lists>.title{
            font-weight: bold;
            font-size: 17px;
            line-height: 30px;
        }
        .notebook-lists>.content{
            color: #303133;
            line-height: 26px;
        }
        .notebook-lists>.time{
            color: #909399;
            font-size: 13px;
            display: flex;
            justify-content: space-between;
        }
        .notebook-lists.warning-active{
            background-color: #f8e3c5!important;
        }
        .notebook-lists.success-active{
            background-color: #d1edc4!important;
        }
        .add{
            font-weight: bold;
            font-size: 22px;
            line-height: 65px;
            position: relative;
            top: 5px;
            margin: 0 5px;
            color: #529b2e;
        }
        .add:hover{
            cursor: pointer;
            color: #129b00;
        }
        .list-tool{
            position: absolute;
            top: 8px;
            right: 10px;
            display: flex;
        }
        .list-tool-item{
            margin: 0 5px;
            font-size: 15px;
        }
        .list-tool-item:hover{
            cursor: pointer;
            font-size: 18px;
            font-weight: bold;
        }
        .delete{
            color: red;
        }
        #fr-logo{ display: none; }
        .fr-popup.fr-active{ z-index: 5 !important; }
        .edit-title{
            border: none;
            border-bottom: 1px solid #C0C4CC;
            outline: none;
            width: 100%;
            font-size: 20px;
            height: 50px;
            font-weight: bold;
            margin-bottom: 5px;
            padding-left: 5px;
            color: #303133;
            box-sizing: border-box;
        }
        .searchInput{
            padding-right: 64px;
            height: 50px;
        }
        .tool{
            position: absolute;
            right: 0;
            top: 10px;
        }
        #app{
            padding: 0 10px 0 5px;
        }
        .content-shade{
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            z-index: 99;
            background-color: #f8e3c535;
        }
        .content-shade .logo{
            font-size: 100px;
            text-align: center;
            color: #f8e3c585;
            line-height: 150px;
            position: absolute;
            top: 50%;
            margin-top: -75px;
            width: 100%;
            user-select: none;
        }
    </style>
@endsection
@section('main')
    <el-row>
        <el-col :span="6">
            <div style="margin: 0 5px 0;padding:0 5px;box-sizing: border-box;position:relative;">
                <input v-model="searchText" class="edit-title searchInput" placeholder="搜索">
                <div class="tool">
                    <el-icon class="add" @click="searchNotebook"><component :is="searchIcon"></component></el-icon>
                    <el-icon class="add" @click="create"><plus/></el-icon>
                </div>
            </div>
            <div v-infinite-scroll="reachBottom" :infinite-scroll-disabled="reachBottomDisabled" style="overflow: auto;height: calc(100vh - 80px)">
                <div @click="notebookToggle(index)" v-for="(item, index) in notebook" class="notebook-lists" :class="{
                'success-background':index % 2,
                'warning-background':!(index % 2),
                'warning-active':index === active && !(index % 2),
                'success-active':index === active && index % 2
            }" >
                    <div class="title">@{{item.title}}</div>
                    <div class="content">@{{item.content.replace(/<\/?.+?>/g,"").replace(/ /g,"").substring(0, 30)}}...</div>
                    <div class="time">创建时间：@{{item.create_time}}</div>
                    <div class="time"><div>创建人：@{{ item.create_name }}</div> <div>最后更新： @{{ item.latest_name }}</div></div>
                    <div class="list-tool">
                        <div class="list-tool-item delete" ><el-icon @click.stop="deleteaa(item, index)"><delete/></el-icon></div>
                    </div>
                </div>
                <el-divider v-if="notNotebook">
                    没有更多笔记了
                </el-divider>
            </div>

        </el-col>
        <el-col :span="18" style="position:relative;">
            <div>
                <input v-model="currentNotebook.title" @change="titleChange" class="edit-title" placeholder="新的笔记">
            </div>
            <div class="content-shade" v-if="!currentNotebook.title">
                <div class="logo">notebook</div>
            </div>
            <div style="border: 1px solid #ccc;">
                <div id="editor-toolbar" style="border-bottom: 1px solid #ccc;"></div>
                <div id="editor-text-area" style="height: calc(100vh - 150px)"></div>
            </div>
        </el-col>
    </el-row>
@endsection

@section('footer')
    <script>
        VueInit.data.notebook = [];
        VueInit.data.active = 0;
        VueInit.data.searchText = "";
        VueInit.data.searchIcon = "Search";
        VueInit.data.editor = "";
        VueInit.data.currentNotebook = {title:''};
        VueInit.data.noteBookVersion = 0;
        VueInit.data.noteBookUpVersion = 0;
        VueInit.data.page = 0;
        VueInit.data.reachBottomDisabled = true;
        VueInit.data.notNotebook = false;

        VueInit.methods.searchNotebook = function () {
            this.page = 1;
            this.getList();
        };

        VueInit.methods.titleChange = function (){
            this.noteBookVersion++;
        }
        const E = window.wangEditor

        // 切换语言
        const LANG = location.href.indexOf('lang=en') > 0 ? 'en' : 'zh-CN'
        E.i18nChangeLanguage(LANG)

        VueInit.data.Weditor = null;
        VueInit.data.Wtoolbar = null;

        VueInit.methods.editorInit = function (content){
            let editor = E.createEditor({
                selector: '#editor-text-area',
                html: content ?? '',
                config: {
                    placeholder: 'Type here...',
                    MENU_CONF: {
                        uploadImage: {
                            maxFileSize: 10 * 1024 * 1024,
                            server: 'file-upload',
                            fieldName: 'file',
                            base64LimitSize: 10 * 1024 // 10k 以下插入 base64
                        }
                    },
                    onChange(editor) {
                        if (VueApp.currentNotebook.content === editor.getHtml()) {
                            return;
                        }
                        VueApp.currentNotebook.content = editor.getHtml();
                        VueApp.noteBookVersion++;
                    },
                    customPaste(editor, event){

                    }
                }
            });
            E.createToolbar({
                editor,
                selector: '#editor-toolbar',
                config: {}
            });
            this.Weditor = editor;
        }
        VueInit.methods.reachBottom = function () {
            if(this.notNotebook){
                return;
            }
            this.page++;
            this.getList();
        };


        VueInit.event.addHandler('mounted:editorInit');
        VueInit.event.addHandler('created:aaaaaa', function (){
            if (this.notebook.length >= 10) {
                this.reachBottomDisabled = false;
            }else{
                this.getList();
            }
        });

        VueInit.methods.notebookToggle = function (index){
            this.active = index;
            this.update();
            this.currentNotebook = this.notebook[index];
            this.noteBookVersion = 0;
            this.noteBookUpVersion = 0;
            this.Weditor.destroy();
            this.editorInit(this.currentNotebook.content ?? '');
            this.getLatest();
        }

        VueInit.methods.deleteaa = function (item, index){
            this.$confirm("确认删除笔记吗？").then(() =>{
                this.notebook.splice(index, 1);
                if (index === this.active) {
                    this.currentNotebook = this.notebook[index] ? this.notebook[index] : {title: ''};
                }
                axios({
                    url:"destroy",
                    method:'post',
                    data:{
                        ids:[item.id]
                    }
                }).then(({data:res}) => {
                    if(res.code === 200){
                        this.$message.success("删除成功");
                    }else{
                        this.$message.error(res.msg);
                    }
                });
            })
        }

        VueInit.methods.create = function (){
            this.notebook.unshift({
                title:"新的笔记",
                content:''
            });
            this.currentNotebook = this.notebook[0];
            axios({
                url: "create",
                method: 'post',
                data: this.currentNotebook
            }).then(({ data:res }) => {
                if (res.code === 200) {
                    for (let key in res.data) {
                        this.currentNotebook[key] = res.data[key];
                    }
                }else{
                    this.$message.error('创建失败！');
                }
            });
        }

        VueInit.methods.update = function (){
            let upVersion = this.noteBookVersion;
            if(this.noteBookUpVersion === upVersion){
                return;
            }
            this.currentNotebook.update_time = this.toTime();
            axios({
                url: "update",
                method: 'post',
                data: this.currentNotebook
            }).then(({ data:res }) => {
                if(res.code !== 200){
                    this.$message.warning(res.msg);
                }else{
                    this.currentNotebook.update_time = this.toTime();
                    this.$notify.success("文档已同步");
                }
            });
            this.noteBookUpVersion = upVersion;
        }
        VueInit.methods.toTime = function () {
            var date = new Date();//时间戳为10位需*1000，时间戳为13位的话不需乘1000
            var Y = date.getFullYear() + '-';
            var M = (date.getMonth()+1 < 10 ? '0'+(date.getMonth()+1):date.getMonth()+1) + '-';
            var D = (date.getDate()< 10 ? '0'+date.getDate():date.getDate())+ ' ';
            var h = (date.getHours() < 10 ? '0'+date.getHours():date.getHours())+ ':';
            var m = (date.getMinutes() < 10 ? '0'+date.getMinutes():date.getMinutes()) + ':';
            var s = date.getSeconds() < 10 ? '0'+date.getSeconds():date.getSeconds();
            return Y+M+D+h+m+s;
        }

        VueInit.event.addHandler('created:updateRegularly', function (){
            setInterval(() => {
                this.update();
                setTimeout(() => this.getLatest(), 1000);
            }, 2000);
        });

        VueInit.methods.getLatest = function (){
            if (!this.currentNotebook.id) {
                return;
            }
            axios({
                url: "get-latest",
                params: {
                    id:this.currentNotebook.id,
                    update_time:this.currentNotebook.update_time,
                }
            }).then(({ data:res }) => {
                if (!res.data) {
                    return;
                }
                this.$notify.success("已获取获取最新笔记");
                this.currentNotebook.latest_name = res.data.latest_name;
                this.currentNotebook.content = res.data.content;
                this.currentNotebook.title = res.data.title;
                this.currentNotebook.update_time = res.data.update_time;
                this.Weditor.destroy();
                this.editorInit(res.data.content ?? '');
            });
        }

        VueInit.methods.getList = function (){
            this.reachBottomDisabled = true;
            axios({
                url:"lists-data",
                params:{
                    search:{
                        searchType: {title:'like'},
                        search: {title:this.searchText},
                    },
                    page:this.page,
                    limit:10
                }
            }).then(({ data:res }) => {
                this.reachBottomDisabled = false;
                if (this.page === 1){
                    this.notebook = res.data.data;
                }else{
                    this.notebook.push(...res.data.data);
                }
                if (res.data.data < 10){
                    this.notNotebook = true;
                }
            })
        }
    </script>
@endsection